<?
/*************************************** 
** Title.........: PWStat 
** Version.......: 0.5
** Author........: Samuel Graenacher <xplo@xplo.org> 
** Filename......: pws.php
** Last changed..: 15/6/2000 
** Notes.........: Program/Script to check various things in the
**                 machine. Accessible via normal browsers AND WAP-only 
**                 devices, thanks to the HAWHAW library 
**                 (www.hawhaw.de) 
**                 Copyright (c) 2000 Samuel Graenacher
***************************************
* Copyright (C) 2000  Samuel Graenacher
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
* To contact the author of this software send an email to xplo@xplo.org.
*/

	include("hawhaw.inc"); // Could need some checking if this exists..	
	
	// Loading configuration.
	include("pws_cfg.php");

	$version = "0.5";

	function pw_check($pass, $cfg_pass)
	{
		// Very lame passwordcheck... soon to be real userverification
		if ($pass == $cfg_pass)
			return true;
		else
			return false;
	}

	if ($s == "login" || $s == "")
	{
		// Login screen..
		$loginp = new HAW_deck("PWS Login", HAW_ALIGN_CENTER);
		$loginp->disable_cache();
		$title = new HAW_text("PWStat ".$version, HAW_TEXTFORMAT_UNDERLINE);
		$title->set_br(2);
		$loginp->add_text($title);
		
		$loginform = new HAW_form("$SCRIPT_NAME");
		$pwtext = new HAW_text("Enter your password to login.", HAW_TEXTFORMAT_SMALL);
		$pwtext->set_br(2);
		$loginform->add_text($pwtext);
		$pwinput = new HAW_input("pw", "", "Login Password");
		$pwinput->set_size(8);
		$pwinput->set_maxlength(8);
		$pwinput->set_type(HAW_INPUT_PASSWORD);
		$loginform->add_input($pwinput);
		$loginsubmit = new HAW_submit("Login");
		$loginform->add_submit($loginsubmit);
		$hidden = new HAW_hidden("s", "main");
		$loginform->add_hidden($hidden);
		
		$loginp->add_form($loginform);
		
		$dummy = new HAW_text(" ");
		$dummy->set_br(2);
		$loginp->add_text($dummy);
		$aboutlink = new HAW_link("About PWStat ".$version, "$SCRIPT_NAME?s=about");
		$loginp->add_link($aboutlink);

		$loginp->create_page();
		exit();

	} elseif (($s == "main") && pw_check($pw, $cfg_pass)) {
		$mainp = new HAW_deck("PWS Main");
		$mainp->disable_cache();
		$title = new HAW_text("PWStat Main", HAW_TEXTFORMAT_UNDERLINE);
		$title->set_br(2);
		$mainp->add_text($title);
		$optxt = new HAW_text("Available Checks:");
		$mainp->add_text($optxt);

		$proclink = new HAW_link("Running Processes", "$SCRIPT_NAME?pw=$pw&s=proc");
		$mainp->add_link($proclink);
		$disklink = new HAW_link("Diskspace", "$SCRIPT_NAME?pw=$pw&s=disk");
		$mainp->add_link($disklink);
		// New screen links here
		$dummy = new HAW_text(" ");
		$dummy->set_br(2);
		$mainp->add_text($dummy);
		$aboutlink = new HAW_link("About PWStat ".$version, "$SCRIPT_NAME?s=about");
		$mainp->add_link($aboutlink);

		$mainp->create_page();

	} elseif ($s == "proc" && pw_check($pw, $cfg_pass)) {
		if (empty($p2c)) {
			// Suggest processes..
			$procp = new HAW_deck("PWS Procs");
			$procp->disable_cache();

			$title = new HAW_text("PWStat ProcessList", HAW_TEXTFORMAT_UNDERLINE);
			$title->set_br(2);
			$procp->add_text($title);
			
			$exp = new HAW_text("Check if a process is running.", HAW_TEXTFORMAT_SMALL);
			$procp->add_text($exp);

			for ($i = 0; $i < count($default_processes); $i++)
			{
				$dp = new HAW_link("$default_processes[$i]", "$SCRIPT_NAME?pw=$pw&s=proc&p2c=$default_processes[$i]");
				$procp->add_link($dp);
				unset($dp);
			}

			$otherf = new HAW_form("$SCRIPT_NAME");
			$hidpw = new HAW_hidden("pw", "$pw");
			$otherf->add_hidden($hidpw);
			$hids = new HAW_hidden("s", "proc");
			$otherf->add_hidden($hids);
			$optxt = new HAW_text("or specify own process");
			$otherf->add_text($optxt);
			$otheri = new HAW_input("p2c", "", "here ");
			$otherf->add_input($otheri);
			$pbut = new HAW_submit("Scan");
			$otherf->add_submit($pbut);
			$procp->add_form($otherf);

			$dummy = new HAW_text(" ");
			$procp->add_text($dummy);
			$back2mn = new HAW_link("Back to Main Menu.", "$SCRIPT_NAME?pw=$pw&s=main");
			$procp->add_link($back2mn);

			$procp->create_page();
			exit;
			
		} else {
			// Show how many times the process is running
			$blah = escapeshellcmd($p2c);
			$toexec = 'ps -ax | grep "'.$blah.'" | grep -v "grep"';
			exec($toexec, $found);

			$procp = new HAW_deck("PWS ProcList");
			$procp->disable_cache();
			$title = new HAW_text("PWStat ProcessList", HAW_TEXTFORMAT_UNDERLINE);
			$title->set_br(2);
			$procp->add_text($title);
			
			if (count($found) == 0)
			{
				// Process is NOT running
				$pitxt = new HAW_text("Process \"$p2c\" is NOT running!");
				$pitxt->set_br(2);
				$procp->add_text($pitxt);
			} else {
				// Process is runing N times
				$amount = count($found);
				$pitxt = new HAW_text("Process \"$p2c\" is running:");
				$procp->add_text($pitxt);
				$pitxt2 = new HAW_text("$amount ", HAW_TEXTFORMAT_BOLD | HAW_TEXTFORMAT_BIG);
				$pitxt2->set_br(0);
				$procp->add_text($pitxt2);
				$pitxt3 = new HAW_text(" time(s).");
				$pitxt3->set_br(2);
				$procp->add_text($pitxt3);
			}
			$chkagain = new HAW_link("Check this proc again.", "$SCRIPT_NAME?pw=$pw&s=proc&p2c=$p2c");
			$procp->add_link($chkagain);
			$back2pl = new HAW_link("Check another process.", "$SCRIPT_NAME?pw=$pw&s=proc");
			$procp->add_link($back2pl);
			$back2mn = new HAW_link("Back to Main Menu.", "$SCRIPT_NAME?pw=$pw&s=main");
			$procp->add_link($back2mn);

			$procp->create_page();
			exit();

		}
	} elseif ($s == "disk" && pw_check($pw, $cfg_pass)) {
		if (empty($mnt)) {
			// Suggest mounts
			$diskp = new HAW_deck("PWS Disks");
			$diskp->disable_cache();

			$title = new HAW_text("PWStat DiskList", HAW_TEXTFORMAT_UNDERLINE);
			$title->set_br(2);
			$diskp->add_text($title);
			
			$exp = new HAW_text("Check Status of a Disk.", HAW_TEXTFORMAT_SMALL);
			$diskp->add_text($exp);

				
			for ($i = 0; $i < count($default_disks); $i++)
			{
				$dp = new HAW_link("$default_disks[$i]", "$SCRIPT_NAME?pw=$pw&s=disk&mnt=$default_disks[$i]");
				$diskp->add_link($dp);
				unset($dp);
			}
			
			$otherf = new HAW_form("$SCRIPT_NAME");
			$hidpw = new HAW_hidden("pw", "$pw");
			$otherf->add_hidden($hidpw);
			$hids = new HAW_hidden("s", "disk");
			$otherf->add_hidden($hids);
			$optxt = new HAW_text("or specify other disk");
			$otherf->add_text($optxt);
			$otheri = new HAW_input("mnt", "", "here ");
			$otherf->add_input($otheri);
			$pbut = new HAW_submit("Scan");
			$otherf->add_submit($pbut);
			$diskp->add_form($otherf);

			$dummy = new HAW_text(" ");
			$diskp->add_text($dummy);
			$back2mn = new HAW_link("Back to Main Menu.", "$SCRIPT_NAME?pw=$pw&s=main");
			$diskp->add_link($back2mn);
			
			$diskp->create_page();
			exit;

		} else {

			$dp = new HAW_deck("PWS DSpace");
			$dp->disable_cache();
			$title = new HAW_text("PWStat DiskSpace", HAW_TEXTFORMAT_UNDERLINE);
			$title->set_br(2);
			$dp->add_text($title);

			// Do the check.
			$blah = escapeshellcmd($mnt);
			$found = exec("df -k \"$blah\" | grep \"$blah\"");
			if (preg_match("/$mountpoint\s+(\d+)\s+(\d+)\s+(\d+)/", $found, $parts) )
			{
				$all = $parts[1];
				$used = $parts[2];
				$free = $parts[3];
				// Ok now output the data..
				$ptxt = new HAW_text("Disk \"$mnt\":");
				$dp->add_text($ptxt);
				$da = new HAW_text("+All:  ".number_format($all, "", ".", "'")." K");
				$dp->add_text($da);
				$du = new HAW_text("+Used: ".number_format($used, "", ".", "'")." K");
				$dp->add_text($du);
				$df = new HAW_text("+Free: ".number_format($free, "", ".", "'")." K");
				$dp->add_text($df);

			} else {
				// Disk wasn't found!
				$de = new HAW_text("The requested Disk was NOT found!");
				$dp->add_text($de);
			}
			$chkagain = new HAW_link("Check this disk again.", "$SCRIPT_NAME?pw=$pw&s=disk&mnt=$mnt");
			$dp->add_link($chkagain);
			$back2pl = new HAW_link("Check another disk.", "$SCRIPT_NAME?pw=$pw&s=disk");
			$dp->add_link($back2pl);
			$back2mn = new HAW_link("Back to Main Menu.", "$SCRIPT_NAME?pw=$pw&s=main");
			$dp->add_link($back2mn);


			$dp->create_page();
			exit;
		}
	} elseif ($s == "about") {
		// Display the about screen
		$aboutp = new HAW_deck("PWS About");
		$aboutp->disable_cache();
		$title = new HAW_text("PWStat ".$version, HAW_TEXTFORMAT_UNDERLINE);
		$title->set_br(2);
		$aboutp->add_text($title);

		$wrby = new HAW_text("Written by:");
		$aboutp->add_text($wrby);
		$samgr = new HAW_text("Samuel Graenacher");
		$samgr->set_br(2);
		$aboutp->add_text($samgr);
		$thxto = new HAW_text("Thanks to:");
		$aboutp->add_text($thxto);
		$es = new HAW_text(" ");
		$es->set_br(0);
		$aboutp->add_text($es);
		$hh = new HAW_link("HAWHAW", "http://www.hawhaw.de");
		$aboutp->add_link($hh);
		$dummy = new HAW_text(" ");
		$dummy->set_br(2);
		$aboutp->add_text($dummy);
		$llink = new HAW_link("Back to Login.", "$SCRIPT_NAME");
		$aboutp->add_link($llink);
		
		$aboutp->create_page();
		exit;

	} else {

		// ERROR!
		$ep = new HAW_deck("PWS Error", HAW_ALIGN_CENTER);
		$title = new HAW_text("ERROR!", HAW_TEXTFORMAT_BOLD | HAW_TEXTFORMAT_BIG);
		$title->set_br(2);
		$ep->add_text($title);
		$txt1 = new HAW_text("There has been an error in processing your request.");
		$ep->add_text($txt1);
		$txt2 = new HAW_text("Either use your BACK button once or you can go");
		$ep->add_text($txt2);
		$lnk1 = new HAW_link("back to the Login", "$SCRIPT_NAME");
		$ep->add_link($lnk1);

		$ep->create_page();
		exit;
	}


?>
